---
title: "Change a certification"
description: "Fields absent from the body are left as they are.\n\n### Quire permissions\n\nRequired capability: `certification/manage`.\n\nCredential scopes: `programs:write`.\n\nThe acting subject must also be allowed to perform this action in the organisation."
image: "https://docs.quirelms.com/og.png"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.quirelms.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Quire API › programs

`PATCH /certifications/{id}`

Fields absent from the body are left as they are.

\### Quire permissions

Required capability: `certification/manage`.

Credential scopes: `programs:write`.

The acting subject must also be allowed to perform this action in the organisation.

## Authentication

Requires one of the following:

- `apiKey`, http, header `Authorization`, scopes: `programs:write`
- `oauth2`, oauth2, scopes: `programs:write`

## Path parameters

- `updateCertification.path.id` (string, required)

## Header parameters

- `updateCertification.header.Quire-Version` (string, optional) — The dated API revision to serve this request at. Omitted, the request is served at the revision the credential was issued against. The response echoes the revision actually applied.
  - format `date`
- `updateCertification.header.Idempotency-Key` (string, optional) — A caller-chosen key making this request safe to retry. A replay of a completed request returns the recorded response with `Idempotency-Replayed: true`. Reusing a key for a different request is refused.
  - maxLength 255

## Request body

_Required._

- `updateCertification.name` (string, optional)
  - minLength 1; maxLength 255
- `updateCertification.summary` (any of, optional)
  - any of: `string`, `null`
- `updateCertification.program_id` (string, optional) — The programme a person completes to be certified.
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `updateCertification.recert_program_id` (any of, optional) — The programme that recertifies; absent or null repeats program_id.
  - any of: `string`, `null`
- `updateCertification.validity_months` (integer, optional)
  - min 1; max 1200
- `updateCertification.expiry_basis` (string, optional)
  - one of `"from_completion"`, `"fixed_calendar"`
- `updateCertification.fixed_month` (any of, optional)
  - any of: `integer`, `null`
- `updateCertification.fixed_day` (any of, optional)
  - any of: `integer`, `null`
- `updateCertification.renewal_basis` (string, optional)
  - one of `"from_expiry"`, `"from_completion"`
- `updateCertification.window_days` (integer, optional) — Recertification opens this many days before expiry. 90 when absent.
  - min 0; max 3650
- `updateCertification.grace_days` (integer, optional) — Still compliant this many days after expiry. 0 when absent.
  - min 0; max 3650
- `updateCertification.evaluation_timezone` (string, optional) — The IANA zone a fixed calendar expiry is read in. UTC when absent.
  - minLength 1; maxLength 64
- `updateCertification.reminder_offsets_days` (array<integer>, optional)
  - min 0; max 3650
- `updateCertification.certificate_template_id` (any of, optional)
  - any of: `string`, `null`
- `updateCertification.badge_class_id` (any of, optional)
  - any of: `string`, `null`

## Example request

```json
{
  "name": "string",
  "summary": "string",
  "program_id": "70c1146b-e933-4cb2-a789-bbca5312b517",
  "recert_program_id": "fe26ec78-77b8-4793-a789-3ec0e39b5056",
  "validity_months": 1,
  "expiry_basis": "from_completion",
  "fixed_month": 1,
  "fixed_day": 1,
  "renewal_basis": "from_expiry",
  "window_days": 3650,
  "grace_days": 3650,
  "evaluation_timezone": "string",
  "reminder_offsets_days": [
    3650
  ],
  "certificate_template_id": "87f8875f-ff97-4f4f-a0ff-493c99ad57fc",
  "badge_class_id": "8f1fd395-e52d-4095-aa7e-fffa69cb4734"
}
```

## Code samples

### cURL

```curl
curl --request PATCH \
  --url https://your-organisation.quirelms.com/api/v1/certifications/string \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": "string",
  "summary": "string",
  "program_id": "70c1146b-e933-4cb2-a789-bbca5312b517",
  "recert_program_id": "fe26ec78-77b8-4793-a789-3ec0e39b5056",
  "validity_months": 1,
  "expiry_basis": "from_completion",
  "fixed_month": 1,
  "fixed_day": 1,
  "renewal_basis": "from_expiry",
  "window_days": 3650,
  "grace_days": 3650,
  "evaluation_timezone": "string",
  "reminder_offsets_days": [
    3650
  ],
  "certificate_template_id": "87f8875f-ff97-4f4f-a0ff-493c99ad57fc",
  "badge_class_id": "8f1fd395-e52d-4095-aa7e-fffa69cb4734"
}
'
```

### TypeScript

```typescript
const url = 'https://your-organisation.quirelms.com/api/v1/certifications/string';
const options = {
  method: 'PATCH',
  headers: {'Content-Type': 'application/json', Authorization: 'Bearer <token>'},
  body: JSON.stringify({
    name: 'string',
    summary: 'string',
    program_id: '70c1146b-e933-4cb2-a789-bbca5312b517',
    recert_program_id: 'fe26ec78-77b8-4793-a789-3ec0e39b5056',
    validity_months: 1,
    expiry_basis: 'from_completion',
    fixed_month: 1,
    fixed_day: 1,
    renewal_basis: 'from_expiry',
    window_days: 3650,
    grace_days: 3650,
    evaluation_timezone: 'string',
    reminder_offsets_days: [3650],
    certificate_template_id: '87f8875f-ff97-4f4f-a0ff-493c99ad57fc',
    badge_class_id: '8f1fd395-e52d-4095-aa7e-fffa69cb4734'
  })
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://your-organisation.quirelms.com/api/v1/certifications/string"

payload = {
    "name": "string",
    "summary": "string",
    "program_id": "70c1146b-e933-4cb2-a789-bbca5312b517",
    "recert_program_id": "fe26ec78-77b8-4793-a789-3ec0e39b5056",
    "validity_months": 1,
    "expiry_basis": "from_completion",
    "fixed_month": 1,
    "fixed_day": 1,
    "renewal_basis": "from_expiry",
    "window_days": 3650,
    "grace_days": 3650,
    "evaluation_timezone": "string",
    "reminder_offsets_days": [3650],
    "certificate_template_id": "87f8875f-ff97-4f4f-a0ff-493c99ad57fc",
    "badge_class_id": "8f1fd395-e52d-4095-aa7e-fffa69cb4734"
}
headers = {
    "Content-Type": "application/json",
    "Authorization": "Bearer <token>"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 200

Success.

#### Example

```json
{
  "id": "string",
  "external_id": "string",
  "name": "string",
  "summary": "string",
  "program_id": "string",
  "recert_program_id": "string",
  "validity_months": -9007199254740991,
  "window_days": -9007199254740991,
  "grace_days": -9007199254740991,
  "is_published": true,
  "created_at": "string",
  "updated_at": "string",
  "deleted_at": "string"
}
```

- `updateCertification.response.200.id` (string, required)
- `updateCertification.response.200.external_id` (string | null, required)
- `updateCertification.response.200.name` (string, required)
- `updateCertification.response.200.summary` (string | null, required)
- `updateCertification.response.200.program_id` (string, required)
- `updateCertification.response.200.recert_program_id` (string | null, required)
- `updateCertification.response.200.validity_months` (integer, required)
  - min -9007199254740991; max 9007199254740991
- `updateCertification.response.200.window_days` (integer, required)
  - min -9007199254740991; max 9007199254740991
- `updateCertification.response.200.grace_days` (integer, required)
  - min -9007199254740991; max 9007199254740991
- `updateCertification.response.200.is_published` (boolean, required)
- `updateCertification.response.200.created_at` (string, required) — RFC 3339 timestamp in UTC.
- `updateCertification.response.200.updated_at` (string, required) — RFC 3339 timestamp in UTC.
- `updateCertification.response.200.deleted_at` (any of, required)
  - any of: `string`, `null`

### 401

The credential is missing, malformed, expired or revoked.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCertification.response.401.type` (string, required)
  - format `uri`
- `updateCertification.response.401.title` (string, required)
- `updateCertification.response.401.status` (integer, required)
- `updateCertification.response.401.code` (string, required)
- `updateCertification.response.401.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCertification.response.401.detail` (string, required)
- `updateCertification.response.401.request_id` (string, required)
- `updateCertification.response.401.docs_url` (string, required)
  - format `uri`
- `updateCertification.response.401.errors` (array<object>, optional)
  - `updateCertification.response.401.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCertification.response.401.errors.code` (string, required)
  - `updateCertification.response.401.errors.detail` (string, required)
- `updateCertification.response.401.retry_after` (integer | null, optional)

### 403

The credential lacks the scope this operation requires, or the acting subject lacks the capability.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCertification.response.403.type` (string, required)
  - format `uri`
- `updateCertification.response.403.title` (string, required)
- `updateCertification.response.403.status` (integer, required)
- `updateCertification.response.403.code` (string, required)
- `updateCertification.response.403.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCertification.response.403.detail` (string, required)
- `updateCertification.response.403.request_id` (string, required)
- `updateCertification.response.403.docs_url` (string, required)
  - format `uri`
- `updateCertification.response.403.errors` (array<object>, optional)
  - `updateCertification.response.403.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCertification.response.403.errors.code` (string, required)
  - `updateCertification.response.403.errors.detail` (string, required)
- `updateCertification.response.403.retry_after` (integer | null, optional)

### 404

No such resource, or none this credential is permitted to know about.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCertification.response.404.type` (string, required)
  - format `uri`
- `updateCertification.response.404.title` (string, required)
- `updateCertification.response.404.status` (integer, required)
- `updateCertification.response.404.code` (string, required)
- `updateCertification.response.404.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCertification.response.404.detail` (string, required)
- `updateCertification.response.404.request_id` (string, required)
- `updateCertification.response.404.docs_url` (string, required)
  - format `uri`
- `updateCertification.response.404.errors` (array<object>, optional)
  - `updateCertification.response.404.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCertification.response.404.errors.code` (string, required)
  - `updateCertification.response.404.errors.detail` (string, required)
- `updateCertification.response.404.retry_after` (integer | null, optional)

### 409

The request conflicts with the current state, with a previous use of the same idempotency key, or with a concurrent write.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCertification.response.409.type` (string, required)
  - format `uri`
- `updateCertification.response.409.title` (string, required)
- `updateCertification.response.409.status` (integer, required)
- `updateCertification.response.409.code` (string, required)
- `updateCertification.response.409.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCertification.response.409.detail` (string, required)
- `updateCertification.response.409.request_id` (string, required)
- `updateCertification.response.409.docs_url` (string, required)
  - format `uri`
- `updateCertification.response.409.errors` (array<object>, optional)
  - `updateCertification.response.409.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCertification.response.409.errors.code` (string, required)
  - `updateCertification.response.409.errors.detail` (string, required)
- `updateCertification.response.409.retry_after` (integer | null, optional)

### 422

The request was understood and its content is not valid. `errors` names each field.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCertification.response.422.type` (string, required)
  - format `uri`
- `updateCertification.response.422.title` (string, required)
- `updateCertification.response.422.status` (integer, required)
- `updateCertification.response.422.code` (string, required)
- `updateCertification.response.422.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCertification.response.422.detail` (string, required)
- `updateCertification.response.422.request_id` (string, required)
- `updateCertification.response.422.docs_url` (string, required)
  - format `uri`
- `updateCertification.response.422.errors` (array<object>, optional)
  - `updateCertification.response.422.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCertification.response.422.errors.code` (string, required)
  - `updateCertification.response.422.errors.detail` (string, required)
- `updateCertification.response.422.retry_after` (integer | null, optional)

### 429

A rate limit or a concurrency cap was reached. `Retry-After` says when to try again.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCertification.response.429.type` (string, required)
  - format `uri`
- `updateCertification.response.429.title` (string, required)
- `updateCertification.response.429.status` (integer, required)
- `updateCertification.response.429.code` (string, required)
- `updateCertification.response.429.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCertification.response.429.detail` (string, required)
- `updateCertification.response.429.request_id` (string, required)
- `updateCertification.response.429.docs_url` (string, required)
  - format `uri`
- `updateCertification.response.429.errors` (array<object>, optional)
  - `updateCertification.response.429.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCertification.response.429.errors.code` (string, required)
  - `updateCertification.response.429.errors.detail` (string, required)
- `updateCertification.response.429.retry_after` (integer | null, optional)

### 500

Something failed at our end. Quote `request_id` when reporting it.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCertification.response.500.type` (string, required)
  - format `uri`
- `updateCertification.response.500.title` (string, required)
- `updateCertification.response.500.status` (integer, required)
- `updateCertification.response.500.code` (string, required)
- `updateCertification.response.500.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCertification.response.500.detail` (string, required)
- `updateCertification.response.500.request_id` (string, required)
- `updateCertification.response.500.docs_url` (string, required)
  - format `uri`
- `updateCertification.response.500.errors` (array<object>, optional)
  - `updateCertification.response.500.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCertification.response.500.errors.code` (string, required)
  - `updateCertification.response.500.errors.detail` (string, required)
- `updateCertification.response.500.retry_after` (integer | null, optional)


Source: https://docs.quirelms.com/api/programs/updateCertification/index.md
